import "./style.css";
import { computed as P, reactive as $, onActivated as j, onDeactivated as J, watch as G, ref as K, resolveComponent as p, openBlock as Q, createBlock as W, withCtx as b, createVNode as h, createElementVNode as f, toDisplayString as X, withDirectives as L, vShow as M } from "vue";
import { Grid as Z, GridColumn as ee } from "@opentiny/vue";
import { PluginPanel as te, SvgButton as oe } from "@opentiny/tiny-engine-common";
import { constants as ne } from "@opentiny/tiny-engine-utils";
import { iconEyeopen as re, iconEyeclose as ce, IconChevronDown as se } from "@opentiny/vue-icon";
import { useCanvas as y, useMaterial as ae, useLayout as q, useMessage as ie } from "@opentiny/tiny-engine-meta-register";
import { extend as le } from "@opentiny/vue-renderless/common/object";
import { typeOf as de } from "@opentiny/vue-renderless/common/type";
const pe = (i, o) => {
  const d = i.__vccOpts || i;
  for (const [n, g] of o)
    d[n] = g;
  return d;
}, { PAGE_STATUS: F } = ne, ge = {
  components: {
    TinyGrid: Z,
    TinyGridColumn: ee,
    PluginPanel: te,
    SvgButton: oe,
    IconEyeopen: re(),
    IconEyeclose: ce()
  },
  props: {
    fixedPanels: {
      type: Array
    }
  },
  emits: ["close", "fix-panel"],
  setup(i) {
    const { pageState: o, getInstance: d } = y(), { getMaterial: n } = ae(), { PLUGIN_NAME: g } = q(), E = P(() => {
      var e;
      return (e = i.fixedPanels) == null ? void 0 : e.includes(g.OutlineTree);
    }), u = (e) => {
      const r = (a) => (a.forEach((s) => {
        s.show = o.nodesStatus[s.id] !== !1, s.showEye = !s.show;
        const w = s.children;
        de(w) !== "array" ? delete s.children : s.children.length && r(s.children);
      }), a);
      return [{ ...r([le(!0, {}, e)])[0], componentName: "body" }];
    }, t = $({
      pageSchema: [],
      expandAll: !0,
      initSchema: [],
      isLock: P(
        () => ![F.Occupy, F.Guest].includes(q().layoutState.pageStatus.state)
      ),
      dragState: {
        allowDrop: !0,
        dragSchema: null,
        hoverVm: null,
        currentVm: null,
        parentNode: null,
        indicator: !0
      }
    }), { subscribe: N, unsubscribe: x } = ie();
    j(() => {
      t.pageSchema = u(o.pageSchema), N({
        topic: "schemaChange",
        subscriber: "node-tree",
        callback: ({ operation: e }) => {
          (e == null ? void 0 : e.type) !== "changeProps" && (t.pageSchema = u(o.pageSchema));
        }
      });
    }), J(() => {
      x({
        topic: "schemaChange",
        subscriber: "node-tree"
      });
    }), G(
      () => o.currentSchema,
      () => {
        const { getSchema: e } = y();
        t.pageSchema = u(e());
      }
    );
    const A = () => {
      t.expandAll = !t.expandAll;
    }, I = (e) => {
      e.show = !e.show, o.nodesStatus[e.id] = e.show;
      const { getRenderer: r, clearSelect: a } = y().canvasApi.value;
      r().setCondition(e.id, e.show), a();
    }, c = (e) => e.componentName ? n(e.componentName).icon || "IconAssociation" : void 0, _ = (e) => {
      if (t.isLock)
        return;
      const { hoverNode: r } = y().canvasApi.value;
      r(e.id), e.showEye = !0;
    }, m = (e) => {
      e && !e.show || (e.showEye = !1);
    }, O = (e) => {
      if (t.isLock)
        return;
      const { selectNode: r } = y().canvasApi.value;
      r(e == null ? void 0 : e.id, "clickTree");
    }, R = K(null), V = () => {
    }, B = ({ row: e }) => {
      var a;
      return "nav-tree " + (((a = o == null ? void 0 : o.currentSchema) == null ? void 0 : a.id) === e.id ? "high-light-node" : "");
    }, U = (e, r) => {
      var D;
      e.dragged.classList.remove("nodrag");
      const { clientY: a } = r, s = e.draggedRect.bottom, w = Math.abs(a - s), C = e.dragged.querySelector(".tree-box").getAttribute("type"), H = e.dragged.querySelector(".tree-box").getAttribute("schemaId"), S = d(H);
      t.dragState.dragSchema = S;
      const T = e.related.querySelector(".tree-box").getAttribute("type"), z = e.related.querySelector(".tree-box").getAttribute("schemaId"), l = d(z);
      o.hoverVm = l;
      const v = (D = S == null ? void 0 : S.componentName) == null ? void 0 : D.container, Y = l == null ? void 0 : l.parent.schema.componentName;
      C === "col" && v && T !== "col" || C === "col" && !v && Y !== "row" || C !== "col" && v && T === "row" ? t.dragState.indicator = !1 : l ? t.dragState.indicator = !0 : t.dragState.indicator = !1, t.dragState.indicator ? (e.dragged.classList.remove("nodrag"), t.dragState.allowDrop = !0) : (e.dragged.classList.add("nodrag"), t.dragState.allowDrop = !1);
      const k = r.target;
      w < 4 && w > 1 && v && (!l.schema.children || l.schema.children.length === 0) && (t.dragState.parentNode = k, k.querySelector(".tiny-grid-tree-wrapper").innerHTML = '<i class="tiny-grid-tree__node-btn tiny-grid-icon__caret-right"></i>'), t.dragState.parentNode && t.dragState.parentNode.getAttribute("data-rowid") !== k.getAttribute("data-rowid") && (t.dragState.parentNode.querySelector(".tiny-grid-tree-wrapper").innerHTML = "", t.dragState.parentNode = null);
    };
    return G(
      () => o.isLock,
      (e) => {
        setTimeout(V, 1e3), t.isLock = e;
      }
    ), {
      panelFixed: E,
      checkElement: O,
      mouseover: _,
      mouseleave: m,
      showNode: I,
      state: t,
      getIcon: c,
      rowDropMove: U,
      gridRef: R,
      toggleTree: A,
      getClassName: B,
      PLUGIN_NAME: g,
      renderIconFn: (e, { isActive: r }) => e(se(), {
        class: ["tiny-grid-tree__node-btn", { is__active: r }]
      })
    };
  }
}, ue = { class: "tree-wrap lowcode-scrollbar" }, me = ["schemaId", "type", "onMouseover", "onMouseleave", "onClick"], he = { class: "tree-content" }, fe = ["onMouseup"];
function ye(i, o, d, n, g, E) {
  const u = p("svg-button"), t = p("icon-eyeopen"), N = p("icon-eyeclose"), x = p("tiny-grid-column"), A = p("tiny-grid"), I = p("plugin-panel");
  return Q(), W(I, {
    class: "outlinebox",
    title: "大纲树",
    onClose: o[1] || (o[1] = (c) => i.$emit("close"))
  }, {
    header: b(() => [
      h(u, {
        class: "item icon-sidebar",
        name: n.panelFixed ? "fixed-solid" : "fixed",
        tips: n.panelFixed ? "解除固定面板" : "固定面板",
        onClick: o[0] || (o[0] = (c) => i.$emit("fix-panel", n.PLUGIN_NAME.OutlineTree))
      }, null, 8, ["name", "tips"])
    ]),
    content: b(() => [
      f("div", ue, [
        h(A, {
          ref: "gridRef",
          data: n.state.pageSchema,
          "tree-config": { children: "children", expandAll: n.state.expandAll, renderIcon: n.renderIconFn },
          "show-header": !1,
          "highlight-hover-row": !1,
          "auto-resize": !0,
          "row-class-name": n.getClassName
        }, {
          default: b(() => [
            h(x, {
              field: "componentName",
              "tree-node": ""
            }, {
              default: b((c) => {
                var _;
                return [
                  f("span", {
                    class: "tree-box",
                    schemaId: (_ = c.row) == null ? void 0 : _.id,
                    type: c.row.componentName,
                    onMouseover: (m) => n.mouseover(c.row),
                    onMouseleave: (m) => n.mouseleave(c.row),
                    onClick: (m) => n.checkElement(c.row)
                  }, [
                    f("span", he, [
                      f("span", null, X(c.row.componentName), 1)
                    ]),
                    L(f("span", {
                      class: "tree-handle",
                      onMouseup: (m) => n.showNode(c.row)
                    }, [
                      L(h(t, null, null, 512), [
                        [M, c.row.show]
                      ]),
                      L(h(N, null, null, 512), [
                        [M, !c.row.show]
                      ])
                    ], 40, fe), [
                      [M, c.row.showEye]
                    ])
                  ], 40, me)
                ];
              }),
              _: 1
            })
          ]),
          _: 1
        }, 8, ["data", "tree-config", "row-class-name"])
      ])
    ]),
    _: 1
  });
}
const _e = /* @__PURE__ */ pe(ge, [["render", ye], ["__scopeId", "data-v-e3e38083"]]), we = {
  id: "engine.plugins.outlinetree",
  title: "大纲树",
  type: "plugins",
  icon: "plugin-icon-tree",
  align: "top"
}, Me = {
  ...we,
  entry: _e
};
export {
  Me as default
};
